/*
 * Ported from Flashlight VNC ActionScript implementation:
 *     http://www.wizhelp.com/flashlight-vnc/
 *
 * Full attribution follows:
 *
 * -------------------------------------------------------------------------
 *
 * This DES class has been extracted from package Acme.Crypto for use in VNC.
 * The unnecessary odd parity code has been removed.
 *
 * These changes are:
 *  Copyright (C) 1999 AT&T Laboratories Cambridge.  All Rights Reserved.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *

 * DesCipher - the DES encryption method
 *
 * The meat of this code is by Dave Zimmerman <dzimm@widget.com>, and is:
 *
 * Copyright (c) 1996 Widget Workshop, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL or COMMERCIAL purposes and
 * without fee is hereby granted, provided that this copyright notice is kept 
 * intact. 
 * 
 * WIDGET WORKSHOP MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
 * OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. WIDGET WORKSHOP SHALL NOT BE LIABLE
 * FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  WIDGET WORKSHOP
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 *
 *
 * The rest is:
 *
 * Copyright (C) 1996 by Jef Poskanzer <jef@acme.com>.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the ACME Labs Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.acme.com/java/
 */
"use strict";function DES(e){function t(e){var t,n,l,a,o,r,s,i,u,d,c=[],p=[],m=[];for(n=0,l=56;56>n;++n,l-=8)l+=-5>l?65:-3>l?31:-1>l?63:27===l?35:0,a=7&l,c[n]=0!==(e[l>>>3]&1<<a)?1:0;for(t=0;16>t;++t){for(a=t<<1,o=a+1,m[a]=m[o]=0,r=28;59>r;r+=28)for(n=r-28;r>n;++n)l=n+y[t],p[n]=r>l?c[l]:c[l-28];for(n=0;24>n;++n)0!==p[b[n]]&&(m[a]|=1<<23-n),0!==p[b[n+24]]&&(m[o]|=1<<23-n)}for(t=0,u=0,d=0;16>t;++t)s=m[u++],i=m[u++],A[d]=(16515072&s)<<6,A[d]|=(4032&s)<<10,A[d]|=(16515072&i)>>>10,A[d]|=(4032&i)>>>6,++d,A[d]=(258048&s)<<12,A[d]|=(63&s)<<16,A[d]|=(258048&i)>>>4,A[d]|=63&i,++d}function n(e){var t,n,l,a,o=0,r=e.slice(),s=0;for(n=r[o++]<<24|r[o++]<<16|r[o++]<<8|r[o++],l=r[o++]<<24|r[o++]<<16|r[o++]<<8|r[o++],a=252645135&(n>>>4^l),l^=a,n^=a<<4,a=65535&(n>>>16^l),l^=a,n^=a<<16,a=858993459&(l>>>2^n),n^=a,l^=a<<2,a=16711935&(l>>>8^n),n^=a,l^=a<<8,l=l<<1|l>>>31&1,a=2863311530&(n^l),n^=a,l^=a,n=n<<1|n>>>31&1,o=0;8>o;++o)a=l<<28|l>>>4,a^=A[s++],t=g[63&a],t|=h[a>>>8&63],t|=p[a>>>16&63],t|=d[a>>>24&63],a=l^A[s++],t|=v[63&a],t|=f[a>>>8&63],t|=m[a>>>16&63],t|=c[a>>>24&63],n^=t,a=n<<28|n>>>4,a^=A[s++],t=g[63&a],t|=h[a>>>8&63],t|=p[a>>>16&63],t|=d[a>>>24&63],a=n^A[s++],t|=v[63&a],t|=f[a>>>8&63],t|=m[a>>>16&63],t|=c[a>>>24&63],l^=t;for(l=l<<31|l>>>1,a=2863311530&(n^l),n^=a,l^=a,n=n<<31|n>>>1,a=16711935&(n>>>8^l),l^=a,n^=a<<8,a=858993459&(n>>>2^l),l^=a,n^=a<<2,a=65535&(l>>>16^n),n^=a,l^=a<<16,a=252645135&(l>>>4^n),n^=a,l^=a<<4,a=[l,n],o=0;8>o;o++)r[o]=(a[o>>>2]>>>8*(3-o%4))%256,r[o]<0&&(r[o]+=256);return r}function l(e){return n(e.slice(0,8)).concat(n(e.slice(8,16)))}var a,o,r,s,i,u,d,c,p,m,h,f,g,v,b=[13,16,10,23,0,4,2,27,14,5,20,9,22,18,11,3,25,7,15,6,26,19,12,1,40,51,30,36,46,54,29,39,50,44,32,47,43,48,38,55,33,52,45,41,49,35,28,31],y=[1,2,4,6,8,10,12,14,15,17,19,21,23,25,27,28],w=0,A=[];return a=65536,o=1<<24,r=a|o,s=4,i=1024,u=s|i,d=[r|i,w|w,a|w,r|u,r|s,a|u,w|s,a|w,w|i,r|i,r|u,w|i,o|u,r|s,o|w,w|s,w|u,o|i,o|i,a|i,a|i,r|w,r|w,o|u,a|s,o|s,o|s,a|s,w|w,w|u,a|u,o|w,a|w,r|u,w|s,r|w,r|i,o|w,o|w,w|i,r|s,a|w,a|i,o|s,w|i,w|s,o|u,a|u,r|u,a|s,r|w,o|u,o|s,w|u,a|u,r|i,w|u,o|i,o|i,w|w,a|s,a|i,w|w,r|s],a=1<<20,o=1<<31,r=a|o,s=32,i=32768,u=s|i,c=[r|u,o|i,w|i,a|u,a|w,w|s,r|s,o|u,o|s,r|u,r|i,o|w,o|i,a|w,w|s,r|s,a|i,a|s,o|u,w|w,o|w,w|i,a|u,r|w,a|s,o|s,w|w,a|i,w|u,r|i,r|w,w|u,w|w,a|u,r|s,a|w,o|u,r|w,r|i,w|i,r|w,o|i,w|s,r|u,a|u,w|s,w|i,o|w,w|u,r|i,a|w,o|s,a|s,o|u,o|s,a|s,a|i,w|w,o|i,w|u,o|w,r|s,r|u,a|i],a=1<<17,o=1<<27,r=a|o,s=8,i=512,u=s|i,p=[w|u,r|i,w|w,r|s,o|i,w|w,a|u,o|i,a|s,o|s,o|s,a|w,r|u,a|s,r|w,w|u,o|w,w|s,r|i,w|i,a|i,r|w,r|s,a|u,o|u,a|i,a|w,o|u,w|s,r|u,w|i,o|w,r|i,o|w,a|s,w|u,a|w,r|i,o|i,w|w,w|i,a|s,r|u,o|i,o|s,w|i,w|w,r|s,o|u,a|w,o|w,r|u,w|s,a|u,a|i,o|s,r|w,o|u,w|u,r|w,a|u,w|s,r|s,a|i],a=8192,o=1<<23,r=a|o,s=1,i=128,u=s|i,m=[r|s,a|u,a|u,w|i,r|i,o|u,o|s,a|s,w|w,r|w,r|w,r|u,w|u,w|w,o|i,o|s,w|s,a|w,o|w,r|s,w|i,o|w,a|s,a|i,o|u,w|s,a|i,o|i,a|w,r|i,r|u,w|u,o|i,o|s,r|w,r|u,w|u,w|w,w|w,r|w,a|i,o|i,o|u,w|s,r|s,a|u,a|u,w|i,r|u,w|u,w|s,a|w,o|s,a|s,r|i,o|u,a|s,a|i,o|w,r|s,w|i,o|w,a|w,r|i],a=1<<25,o=1<<30,r=a|o,s=256,i=1<<19,u=s|i,h=[w|s,a|u,a|i,r|s,w|i,w|s,o|w,a|i,o|u,w|i,a|s,o|u,r|s,r|i,w|u,o|w,a|w,o|i,o|i,w|w,o|s,r|u,r|u,a|s,r|i,o|s,w|w,r|w,a|u,a|w,r|w,w|u,w|i,r|s,w|s,a|w,o|w,a|i,r|s,o|u,a|s,o|w,r|i,a|u,o|u,w|s,a|w,r|i,r|u,w|u,r|w,r|u,a|i,w|w,o|i,r|w,w|u,a|s,o|s,w|i,w|w,o|i,a|u,o|s],a=1<<22,o=1<<29,r=a|o,s=16,i=16384,u=s|i,f=[o|s,r|w,w|i,r|u,r|w,w|s,r|u,a|w,o|i,a|u,a|w,o|s,a|s,o|i,o|w,w|u,w|w,a|s,o|u,w|i,a|i,o|u,w|s,r|s,r|s,w|w,a|u,r|i,w|u,a|i,r|i,o|w,o|i,w|s,r|s,a|i,r|u,a|w,w|u,o|s,a|w,o|i,o|w,w|u,o|s,r|u,a|i,r|w,a|u,r|i,w|w,r|s,w|s,w|i,r|w,a|u,w|i,a|s,o|u,w|w,r|i,o|w,a|s,o|u],a=1<<21,o=1<<26,r=a|o,s=2,i=2048,u=s|i,g=[a|w,r|s,o|u,w|w,w|i,o|u,a|u,r|i,r|u,a|w,w|w,o|s,w|s,o|w,r|s,w|u,o|i,a|u,a|s,o|i,o|s,r|w,r|i,a|s,r|w,w|i,w|u,r|u,a|i,w|s,o|w,a|i,o|w,a|i,a|w,o|u,o|u,r|s,r|s,w|s,a|s,o|w,o|i,a|w,r|i,w|u,a|u,r|i,w|u,o|s,r|u,r|w,a|i,w|w,w|s,r|u,w|w,a|u,r|w,w|i,o|s,o|i,w|i,a|s],a=1<<18,o=1<<28,r=a|o,s=64,i=4096,u=s|i,v=[o|u,w|i,a|w,r|u,o|w,o|u,w|s,o|w,a|s,r|w,r|u,a|i,r|i,a|u,w|i,w|s,r|w,o|s,o|i,w|u,a|i,a|s,r|s,r|i,w|u,w|w,w|w,r|s,o|s,o|i,a|u,a|w,a|u,a|w,r|i,w|i,w|s,r|s,w|i,a|u,o|i,w|s,o|s,r|w,r|s,o|w,a|w,o|u,w|w,r|u,a|s,o|s,r|w,o|i,o|u,w|w,r|u,a|i,a|i,w|u,w|u,a|s,o|w,r|i],t(e),{encrypt:l}}